//----------------------------------------------------------------------//
// ėpʊ֐															//
//																		//
//----------------------------------------------------------------------//
#ifndef UsrFuncH
#define UsrFuncH

//---------------------------------------------------------------------------
#include <Vcl.ComCtrls.hpp>
#include <Vcl.Buttons.hpp>
#include <Vcl.Grids.hpp>
#include <Vcl.CheckLst.hpp>
#include "usr_str.h"
#include "usr_key.h"
#include "usr_msg.h"
#include "usr_color.h"
#include "usr_file_ex.h"
#include "usr_file_inf.h"

//---------------------------------------------------------------------------
#define URL_MATCH_PTN	_T("h?ttps?://[\\w/:%#$&?()~.=+-]+[\\w/]")		//URLpK\
#define MAIL_MATCH_PTN	_T("mailto:[a-zA-Z0-9]+[\\w.-]*@[\\w.-]+")		//[pK\
#define LOCAL_FILE_PTN	_T("file:///[^*?\"<>|)j]+\\.[a-zA-Z0-9]+")		//[Jt@C̐K\

#define LISTBOX_SCRMGN	2

//---------------------------------------------------------------------------
bool is_SnapToDefBtn();

HWND get_window_from_pos();
TRect get_window_rect(HWND hWnd);
void set_window_pos_ex(HWND hWnd, TRect rc);
void adjust_form_pos(TForm *frm);
int  show_ModalDlg(TForm *dlg);

void show_PopupMenu(TPopupMenu *mp, TControl *cp);
void show_PopupMenu(TListBox *cp);
void show_PopupMenu(TCheckListBox *cp);
void show_PopupMenu(TStringGrid *gp);

void set_ListBoxText(TListBox *lp, const _TCHAR *s);
void set_ComboBoxText(TComboBox *cp, const _TCHAR *s);

void add_ComboBox_history(TComboBox *cp, UnicodeString kwd = EmptyStr);
int  del_ComboBox_history(TComboBox *cp, UnicodeString kwd = EmptyStr);

UnicodeString GetClipboardText(bool top_sw = false);

bool is_IME_Open(HWND hWnd);
bool is_IME_Typing(HWND hWnd);
bool is_IME_Empty(HWND hWnd);
void CloseIME(HWND hWnd);

TPoint get_ListItemPos(TListBox *lp, int xp = 0);
void pos_ListBoxItem(TListBox *lp, int xp = 0);

//---------------------------------------------------------------------------
bool has_Leading(TCanvas *cv);
int  get_CharWidth_Font(TFont *font, int n);

int  EditToInt(TLabeledEdit *ep, int def = 0);
int  EditToInt(TEdit *ep, int def = 0);

TDate set_NormDay(unsigned short y, unsigned short m, unsigned short d);
bool ToDateTime(UnicodeString s, TDateTime *dt);
UnicodeString format_DateTime(TDateTime dt, bool omit = false);
UnicodeString format_Date(TDateTime dt);
UnicodeString format_DateTimeEx(UnicodeString fmt, TDateTime dt);

int get_DateCond(UnicodeString prm, TDateTime &dt);

int  format_res_list(TStringList *lst, int mgn = 2, int min_wd = 16);

void ShowPropertyDialog(UnicodeString fnam);

void delete_ListItem(TCustomListBox *lp);
void draw_ListItemLine(TCustomListBox *lp, int idx);

void draw_Line(TCanvas *cv, int x0, int y0, int x1, int y1, int w, TColor col, TPenStyle = psSolid);
void draw_Separator(TCanvas *cv, TRect rc, TColor bg = Graphics::clNone);
void draw_separateLine(TCanvas *cv, TRect rc, int pos = 0);

double get_ZoomRatio(int vw, int vh, int iw, int ih, int mgn = 0, double limit = 1.0);

void alpha_blend_Rect(TCanvas *cv, int x, int y, int w, int h, TColor col, int alpha);
void alpha_blend_Rect(TCanvas *cv, TRect rc, TColor col, int alpha);

void init_UpDown(TUpDown *udp, int n);

void set_GridFromHeader(THeaderControl *hp, TStringGrid *gp);
void set_HeaderFromGrid(TStringGrid *gp, THeaderControl *hp);
void set_HeaderSecWidth(THeaderControl *hp, int cnt, ...);
void adjust_HeaderSecWidth(THeaderControl *hp, int idx);

int  set_SttBarPanelWidth(TStatusBar *sp, int idx, int n);
int  set_SttBarPanelWidth(TStatusBar *sp, int idx, UnicodeString s);

void clear_GridRow(TStringGrid *gp, int row, int col = 0);
int  get_GridIndex(TStringGrid *gp, int max_count);
void set_GridIndex(TStringGrid *gp, int idx, int max_count, bool center = false);

void ListBoxCursorDown(TListBox *lp);
void ListBoxCursorDown(TListBox *lp, int n);
void ListBoxCursorUp(TListBox *lp);
void ListBoxCursorUp(TListBox *lp, int n);
void ListBoxPageDown(TListBox *lp);
void ListBoxPageUp(TListBox *lp);
void ListBoxTop(TListBox *lp);
void ListBoxEnd(TListBox *lp);
void ListBoxSetIndex(TListBox *lp, int idx, bool top_sw = false);
bool ListBoxCsrToVisible(TListBox *lp);
void ListBoxScrollDown(TListBox *lp, int n, bool move_csr = false);
void ListBoxScrollDown(TListBox *lp, UnicodeString prm);
void ListBoxScrollUp(TListBox *lp, int n, bool move_csr = false);
void ListBoxScrollUp(TListBox *lp, UnicodeString prm);
void ListBoxSelectAll(TListBox *lp, bool sw = true);
int  ListBoxInitialSearch(TListBox *lp, UnicodeString kptn, bool fnam_sw = false);
UnicodeString InfListBoxGetDir(TListBox *lp);
UnicodeString ListBoxGetURL(TListBox *lp);
void set_ListBox_ItemNo(TListBox *lp);
int get_CheckListCount(TCheckListBox *lp);

void GridCursorLeft(TStringGrid *gp);
void GridCursorRight(TStringGrid *gp);
void GridCursorDown(TStringGrid *gp);
void GridCursorUp(TStringGrid *gp);
void GridPageDown(TStringGrid *gp);
void GridPageUp(TStringGrid *gp);
bool GridCursorMove(UnicodeString cmd , TStringGrid *gp);

int up_StrListItem(TStringList *lst, int idx);
int down_StrListItem(TStringList *lst, int idx);

int get_IndexFromAccKey(TStringList *lst, UnicodeString key);

UnicodeString extract_URL(UnicodeString s);

bool InternetConnected();
int  get_OnlineFile(UnicodeString url, UnicodeString fnam, bool *cancel = NULL,
		TPaintBox *prg_box = NULL, double *prg_ratio = NULL);

void set_SplitterWidht(TSplitter *sp, int sp_wd);
void set_PanelAlign(TPanel *pp, TSplitter *sp, int mode,  int sp_wd);
void set_PanelAlign(TPanel *pp, TSplitter *sp, TAlign al, int sp_wd);

void set_ControlRBCorner(TControl *cp0, TControl *cp1);

UnicodeString get_BatteryPercentStr();
UnicodeString get_BatteryTimeStr();

bool EjectDrive(UnicodeString drvnam, bool eject);
bool EjectDrive2(UnicodeString drvnam, bool eject);

bool class_is_LabeledEdit(TObject *op);
bool class_is_MaskEdit(TObject *op);
bool class_is_CustomEdit(TObject *op);
bool class_is_Edit(TObject *op);
bool class_is_CheckBox(TObject *op);
bool class_is_ComboBox(TObject *op);
bool class_is_ListBox(TObject *op);
bool class_is_CheckListBox(TObject *op);
bool class_is_RadioGroup(TObject *op);

void cursor_HourGlass();
void cursor_Default();

void reduction_MenuLine(TMenuItem *mp);

//---------------------------------------------------------------------------
extern UnicodeString WebSeaUrl;
UnicodeString get_WebSeaCaption(UnicodeString kwd = EmptyStr, bool with_ak = true);
bool exe_WebSearch(UnicodeString kwd);

//---------------------------------------------------------------------------
extern bool DebugOut;
void OutDebugStr(UnicodeString s);
//---------------------------------------------------------------------------
#endif
